Bug 138563 - [PATCH] RHEL4 U1: EFI GPT: reduce alternate header probing
[PATCH] RHEL4 U1: EFI GPT: reduce alternate header probing
Product: Red Hat Enterprise Linux 4
Classification: Red Hat
Component: kernel (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Jason Baron
Depends On:
Blocks: 147461
  Show dependency treegraph
Reported: 2004-11-09 17:00 EST by Matt Domsch
Modified: 2013-03-06 00:57 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2005-04-18 09:59:00 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
efi.patch (12.75 KB, patch)
2004-11-09 17:01 EST, Matt Domsch
no flags Details | Diff

  None (edit)
Description Matt Domsch 2004-11-09 17:00:09 EST
Description of problem:
Date: Tue, 9 Nov 2004 15:59:36 -0600
From: Matt Domsch <Matt_Domsch@dell.com>
To: Linus Torvalds <torvalds@osdl.org>, akpm@osdl.org
Cc: davej@redhat.com, "Luck, Tony" <tony.luck@intel.com>,
        linux-kernel@vger.kernel.org, linux-ia64@vger.kernel.org
Subject: [PATCH 2.6] EFI GPT: reduce alternate header probing
In-Reply-To: <20041109214935.GA617@lists.us.dell.com>

EFI partitioning scheme was reading the last reported sector of the
block device to look for the alternate GPT header, before it had
confirmed that it should.  This causes problems for devices with the
following problems:  a) those who misreport their size (typically
off-by-one), and b) those who fail when asked to read a block
outside their range.

This patch moves the test for the Protective Master Boot Record (PMBR)
ahead of the tests for the Primary and Alternate GPT headers.  If the
PMBR is not valid, the disk is assumed to not be a GPT disk.  This can
be overridden with the 'gpt' kernel command line option.  If the
Primary GPT header is not valid, the Alternate GPT header is not
probed automatically unless the 'gpt' kernel command line option is
passed.  If the both the PMBR and Primary GPT header are valid, then
the Alternate GPT header at the end of the disk is probed.

Also re-enables CONFIG_EFI_PARTITION for all architectures.

Signed-off-by: Matt Domsch <Matt_Domsch@dell.com>

Version-Release number of selected component (if applicable):

How reproducible:

Steps to Reproduce:
Actual results:

Expected results:

Additional info:
Comment 1 Matt Domsch 2004-11-09 17:01:22 EST
Created attachment 106378 [details]

patch sent to lkml
Comment 2 Matt Domsch 2004-11-10 12:30:38 EST
This patch was committed to Linus's BK tree overnight.
Comment 4 Matt Domsch 2004-12-02 22:35:38 EST
Not fixed in 2.6.9-1.849_EL yet.
Comment 5 Matt Domsch 2004-12-09 16:26:50 EST
Not fixed in 2.6.9-1.871_EL yet.
As I believe this won't get applied for gold, change $subject to U1.
Comment 7 Amit Bhutani 2005-01-25 15:15:10 EST
Changing the title to reflect the Update in which a fix for this 
issue has been committed or being tracked for..
Comment 8 Jason Baron 2005-02-10 11:44:48 EST
I don't see this work in upstream 2.4. Is it not needed there for some reason?
or just not merged? The basic question is whether we should merge this back to
rhel2.1 and rhel3. thanks.
Comment 9 Matt Domsch 2005-02-10 12:21:25 EST
I never submitted it to upstream 2.4, you're correct.  Essentially because 
CONFIG_EFI_PARTITION is not enabled on any architecture except IA64, and given 
the scarcity of IA64 hardware, it's unlikely that people will plug broken 
iPods (or other similarly broken yet not-on-the-quirks-list storage) devices 
into such systems.

If you're adding the iPods to the USB "unusual_devs.h" list, then I don't need 
to fix the partition code.  If you're not, and we care about people plugging 
broken iPods into IA64 systems, then yes, I should fix it.  I'm inclined 
against it though.

The fix *does* need to make it into RHEL4 though.

Comment 12 Jay Turner 2005-04-16 14:02:30 EDT
Dell, are things better with the U1-candidate kernel?
Comment 13 Matt Domsch 2005-04-18 09:59:00 EDT
Confirmed fixed in 2.6.9-6.37, thanks!
Comment 14 Tim Powers 2005-06-08 11:12:51 EDT
An advisory has been issued which should help the problem
described in this bug report. This report is therefore being
closed with a resolution of ERRATA. For more information
on the solution and/or where to find the updated files,
please follow the link below. You may reopen this bug report
if the solution does not work for you.


Note You need to log in before you can comment on or make changes to this bug.